<?php

if( ! class_exists('Ph_Bookings_Combo_Participant_settings') ) {
	class Ph_Bookings_Combo_Participant_settings {

		public function __construct() {
			if( isset($_POST['ph_booking_customize_participant_deduction']) )
			{
				$this->save_settings();
			}
			$this->init();
			$this->product_id="";
		}

		public function init() {
			$this->settings=get_option(PH_BOOKING_PARTICIPANT_SETTING_ID,false);

			$this->participant_name=isset($this->settings['participant_name'])?$this->settings['participant_name']:'';
			$this->participant_deduction=isset($this->settings['participant_deduction'])?$this->settings['participant_deduction']:'';
			add_action(	'admin_menu', array( $this, 'ph_booking_admin_submenu' ), 11 );
			add_filter('ph_bookings_all_bookings_query',array( $this, 'ph_bookings_update_all_bookings_query' ));
			add_filter('ph_bookings_extra_key_value',array( $this, 'ph_bookings_add_extra_key_value' ),10,3);
			add_filter('ph_bookings_check_participant_adjustment',array( $this, 'ph_bookings_check_participant_adjustment' ),10,3);
			add_filter('ph_booking_booked_participant_list',array( $this, 'ph_booking_update_booked_participant_list' ),10,3);
		}

		/**
		 * Add SubMenu to Bookings Menu.
		 */
		public function ph_booking_admin_submenu() {
			add_submenu_page(
				"bookings",
				"Booking Participant Group Settings",
				__("Participant Groups Settings",'bookings-and-appointments-for-woocommerce'),
				"manage_options",
				"bookings-participant-group-settings", 
				array( $this, "combo_participant_settings_page" )
			);
		}

		/**
		 * Settings Page
		 */
		public function combo_participant_settings_page(){
			include 'ph-settings-html.php';
		}

		/**
		 * Save Settings
		 */
		public function save_settings() {
			$settings_array=array('participant_name'=>$_POST['participant_name'],
									'participant_deduction'=>$_POST['participant_deduction']);
			update_option( PH_BOOKING_PARTICIPANT_SETTING_ID, $settings_array );
		}
		public function ph_bookings_update_all_bookings_query($query){
			$participant_name=$this->participant_name;
			$query_array=explode("OR meta_key = 'Buffer_after_To'", $query);
			$query_string=$query_array[0]." OR meta_key = 'Buffer_after_To' OR meta_key = '".$participant_name."' ".$query_array[1]; 
			// error_log(print_r($query_string,true));
			return $query_string;
		}

		public function ph_bookings_add_extra_key_value($stored_values,$order_item_id,$new_value){
			$participant_name=$this->participant_name;
			// error_log(print_r($stored_values,true));
			if( $new_value->meta_key=='participants'  ){
					$stored_values[$order_item_id]['participants'] = $new_value->meta_value;
			}
			if( $new_value->meta_key== $participant_name ){
					$stored_values[$order_item_id][$participant_name] = $new_value->meta_value;
			}
			return $stored_values;
		}
		public function ph_bookings_check_participant_adjustment($number_of_persons,$booking_details,$product_id){
			$participant_name=$this->participant_name;
			$participant_deduction=$this->participant_deduction;
			global $product;
			$participant_pricing_rules=array();
			error_log("message");
			if(!empty($product) || !empty($product_id))
			{
				$product_id=empty($product_id)?$product->get_id():$product_id;
				$product_properties = get_post_meta( $product_id );
				$participant_pricing_rules 	= !empty($product_properties['_phive_booking_persons_pricing_rules'][0]) ? maybe_unserialize($product_properties['_phive_booking_persons_pricing_rules'][0]) : array();
			}
			if(isset($booking_details[$participant_name]))
			{
				$number_of_persons=($number_of_persons-$booking_details[$participant_name])+$booking_details[$participant_name]*$participant_deduction;
			}
			elseif(isset($booking_details['participants']))
			{
				$participants=unserialize($booking_details['participants']);
				foreach ($participant_pricing_rules as $key => $value) {
						if($value['ph_booking_persons_rule_type']==$participant_name && isset($participants[$key]))
						{
							$number_of_persons=($number_of_persons-$participants[$key])+$participants[$key]*$participant_deduction;
							break;
						}
				}
			}
			return $number_of_persons;
		}
		public function ph_booking_update_booked_participant_list($number_of_persons,$participant_list,$product_id){
			$participant_name=$this->participant_name;
			$participant_deduction=$this->participant_deduction;
			// global $product;
			$participant_pricing_rules=array();
			if(!empty($product_id))
			{
				$this->product_id=$product_id;
				$product_properties = get_post_meta( $product_id );
				$participant_pricing_rules 	= !empty($product_properties['_phive_booking_persons_pricing_rules'][0]) ? maybe_unserialize($product_properties['_phive_booking_persons_pricing_rules'][0]) : array();
			}
			if(!empty($participant_list))
			{
				foreach ($participant_pricing_rules as $key => $value) {
						if($value['ph_booking_persons_rule_type']==$participant_name && isset($participant_list[$key]))
						{
							$number_of_persons=($number_of_persons-$participant_list[$key])+$participant_list[$key]*$participant_deduction;
							break;
						}
				}
			}
			return $number_of_persons;
		}


	}
}

new Ph_Bookings_Combo_Participant_settings();