<?php
/**
 * Plugin Name: Booking Participant Groups
 * Plugin URI: https://pluginhive.com/
 * Description: An Add-on for PluginHive Woocommerce Bookings to set booking participants group and assign number of group members to that participant.
 * Version: 1.0.0
 * Author: pluginhive
 * Author URI: https://pluginhive.com
 * Text Domain: bookings-and-appointments-for-woocommerce
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

// Define PH_BOOKINGS_INTERVAL_PLUGIN_FILE.
if ( ! defined( 'PH_BOOKINGS_COMBO_PARTICIPANT_PLUGIN_FILE' ) )
	define( 'PH_BOOKINGS_COMBO_PARTICIPANT_PLUGIN_FILE', __FILE__ );

	define( 'PH_BOOKING_PARTICIPANT_SETTING_ID', 'ph_booking_customize_participant_deduction' );

if( ! class_exists('Ph_Bookings_Combo_participant') ) {
	class Ph_Bookings_Combo_participant {

		/**
		 * Constructor
		 */
		public function __construct() {
			$this->init();
			add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), array( $this, 'plugin_action_links' ) );
			
		}

		/**
		 * Init
		 */
		public function init(){
			if( ! class_exists('Ph_Bookings_Notification_Settings') )
				include_once 'includes/class-ph-bookings-combo-participant-settings.php';
		}

		function plugin_action_links( $links ) {
		
			$plugin_links = array(
				'<a href="'.admin_url('admin.php?page=bookings-participant-group-settings').'" >' . __('Settings', 'ph-bookings-reminder-notifications') . '</a>',
			);
			return array_merge( $plugin_links, $links );
		
		}

	}
}
new Ph_Bookings_Combo_participant();